aboutsummaryrefslogtreecommitdiffstats
path: root/sh
diff options
context:
space:
mode:
authorDavid Else <12832280+David-Else@users.noreply.github.com>2024-06-01 23:07:35 +0100
committerGitHub <noreply@github.com>2024-06-02 06:07:35 +0800
commit842f5f08c9fe63c1177b6acc1dd7647276e5bde2 (patch)
tree85d502263ae4011f788ae02bb42a88bfa0f297d4 /sh
parent55a72d7ad235894cf268ddf1f16181533f71ab96 (diff)
downloadllm-functions-docker-842f5f08c9fe63c1177b6acc1dd7647276e5bde2.tar.gz
feat: add `get_web_page` (#11)
Diffstat (limited to 'sh')
-rwxr-xr-xsh/get_web_page.sh14
1 files changed, 14 insertions, 0 deletions
diff --git a/sh/get_web_page.sh b/sh/get_web_page.sh
new file mode 100755
index 0000000..65e6d2a
--- /dev/null
+++ b/sh/get_web_page.sh
@@ -0,0 +1,14 @@
+#!/usr/bin/env bash
+set -e
+
+# @describe Fetches the HTML content from a specified webpage URL and converts it to Markdown format.
+# Use it to answer user questions that require up-to-date content from web pages.
+# @meta require-tools curl,pandoc,sed
+# @option --url! The URL to scrape.
+
+main() {
+ # span and div tags are dropped from the HTML https://pandoc.org/MANUAL.html#raw-htmltex and sed removes any inline SVG images in image tags from the Markdown content.
+ curl -fsSL "$argc_url" | pandoc -f html-native_divs-native_spans -t gfm-raw_html | sed -E 's/!\[.*?\]\((data:image\/svg\+xml[^)]+)\)//g'
+}
+
+eval "$(argc --argc-eval "$0" "$@")"